﻿using System;
using System.Web;
using Raven.Client;

public partial class _Default : System.Web.UI.Page
{
    private IDocumentSession RavenSession
    {
        get { return (IDocumentSession) HttpContext.Current.Items["CurrentRequestRavenSession"]; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        
    }
    protected void BtnSalvar_Click(object sender, EventArgs e)
    {
        if (string.IsNullOrEmpty(HidId.Value))
        {
            Livro novoLivro = new Livro
                                  {
                                      Nome = TxtNome.Text,
                                      Preco = decimal.Parse(TxtPreco.Text),
                                      Autores = TxtAutores.Text.Split(new[] { Environment.NewLine }, StringSplitOptions.RemoveEmptyEntries)
                                  };

            RavenSession.Store(novoLivro);
            RavenSession.SaveChanges();
        }
        else
        {
            Livro livroEditado = RavenSession.Load<Livro>("livros/" + HidId.Value);

            livroEditado.Nome = TxtNome.Text;
            livroEditado.Preco = decimal.Parse(TxtPreco.Text);
            livroEditado.Autores = TxtAutores.Text.Split(new[] { Environment.NewLine }, StringSplitOptions.RemoveEmptyEntries);

            RavenSession.SaveChanges();
        }

        HidId.Value = "";
        TxtNome.Text = "";
        TxtPreco.Text = "";
        TxtAutores.Text = "";
        LblEditando.Text = "";
    }

    protected void BtnNovo_Click(object sender, EventArgs e)
    {
        HidId.Value = "";
        TxtNome.Text = "";
        TxtPreco.Text = "";
        TxtAutores.Text = "";
        LblEditando.Text = "";
    }

    protected void BtnVisualizar_Click(object sender, EventArgs e)
    {
        string id = TxtId.Text.Trim();
        Livro livro = RavenSession.Load<Livro>("livros/" + id);

        if (livro != null)
        {
            TxtNome.Text = livro.Nome;
            TxtPreco.Text = livro.Preco.ToString();
            TxtAutores.Text = string.Join(Environment.NewLine, livro.Autores);
            LblEditando.Text = "Editando Livro com Id " + livro.Id;

            HidId.Value = id;
        }
        else
        {
            HidId.Value = "";
            TxtNome.Text = "";
            TxtPreco.Text = "";
            TxtAutores.Text = "";
            LblEditando.Text = "Não encontrado";
        }
    }

    protected void BtnApagar_Click(object sender, EventArgs e)
    {
        string id = HidId.Value;
        Livro livroApagado = RavenSession.Load<Livro>("livros/" + id);
        RavenSession.Delete(livroApagado);
        RavenSession.SaveChanges();

        HidId.Value = "";
    }

    protected void BtnVisualizarTodos_Click(object sender, EventArgs e)
    {
        GrvTodos.DataSource = RavenSession.Query<Livro>();
        GrvTodos.DataBind();
    }
}